DECLARE FUNCTION XWIN% (B1 AS INTEGER, B2 AS INTEGER, B3 AS INTEGER, L AS INTEGER)
DECLARE FUNCTION OWIN% (B1 AS INTEGER, B2 AS INTEGER, B3 AS INTEGER, L AS INTEGER)
DECLARE SUB WINNER (LINEUP AS INTEGER)
DECLARE SUB SHOWWIN (B1 AS INTEGER, B2 AS INTEGER, B3 AS INTEGER)
DECLARE SUB GETUSERSIGNAL ()
DECLARE SUB ENABLEMOUSE (C%)
DECLARE SUB DRAWSCREEN ()
DECLARE SUB XO (ROW%, COL%, SYMBOL%)

DIM SHARED FALSE AS INTEGER, TRUE AS INTEGER: TRUE = NOT FALSE
DIM SHARED SYMBOLBOX(6000) AS INTEGER '<---NOTE

DIM SHARED CH AS INTEGER: 'CURSOR POSITION HORIZONTAL
DIM SHARED CV AS INTEGER: 'CURSOR POSITION VERTICAL
DIM SHARED CLICK AS INTEGER: ' 0=NO CLICK, 1=LEFT CLICK, 2=RIGHT
' ENABLEMOUSE 1 = TURN CURSOR ON, RETURN COORDINATES
' ENABLEMOUSE 0 = TURN CURSOR OFF IN ORDER TO DRAW STUFF, ETC.
DIM SHARED CC AS STRING: 'USER PRESSED KEY
' GETUSERSIGNAL WILL SET RETURN CC OR WILL RETURN CLICK

DIM I AS INTEGER, J AS INTEGER, K AS INTEGER
DIM WHOWON AS INTEGER
DIM MADEAMOVE AS INTEGER, MOVESMADE AS INTEGER

' ----------------------------------------------------------
'                TITLE SCREEN (MAIN PROGRAM)
' -----------------------------------------------------------
SCREEN 12
RANDOMIZE TIMER
DIM COMMAND AS INTEGER, HARD AS INTEGER
GOSUB INITIALIZESCREEN
DO
    DO: GETUSERSIGNAL: LOOP UNTIL CLICK = 1
    GOSUB FINDCLICKEDCOMMAND
    SELECT CASE COMMAND
        CASE 1:
            HARD = FALSE
            WHOWON = 0
            GOSUB PLAYGAME
            GOSUB SHOWWHOWON
            GOSUB INITIALIZESCREEN
        CASE 2:
            HARD = TRUE
            WHOWON = 0
            GOSUB PLAYGAME
            GOSUB SHOWWHOWON
            GOSUB INITIALIZESCREEN
        CASE 3:
            GOSUB DOHELP
            GOSUB INITIALIZESCREEN
        CASE 4:
            EXIT DO
    END SELECT
LOOP
COLOR 7: CLS
SYSTEM

' ----------------------------------------------------------
'                GAME SCREEN
' -----------------------------------------------------------
DIM SHARED ZX(9) AS INTEGER: ' WHERE ALL X'S ARE PLACED
DIM SHARED ZO(9) AS INTEGER: ' WHERE ALL O'S ARE PLACED
DIM SHARED ZE(9) AS INTEGER: ' WHERE EMPTY SQUARES ARE
DIM THEROW AS INTEGER, THECOLUMN AS INTEGER, THEBOX AS INTEGER

FINDCLICKEDPOSITION:
CONST DELTA = 4
THEROW = 0: THECOLUMN = 0: THEBOX = 0
SELECT CASE CH
    CASE IS < 170 + DELTA: RETURN
    CASE IS < 269 - DELTA: THECOLUMN = 1
    CASE IS < 269 + DELTA: RETURN
    CASE IS < 368 - DELTA: THECOLUMN = 2
    CASE IS < 368 + DELTA: RETURN
    CASE IS < 467 - DELTA: THECOLUMN = 3
    CASE ELSE: RETURN
END SELECT
SELECT CASE CV
    CASE IS < 91 + DELTA: RETURN
    CASE IS < 190 - DELTA: THEROW = 1
    CASE IS < 190 + DELTA: RETURN
    CASE IS < 289 - DELTA: THEROW = 2
    CASE IS < 289 + DELTA: RETURN
    CASE IS < 388 - DELTA: THEROW = 3
    CASE ELSE: RETURN
END SELECT
THEBOX = (3 * (THEROW - 1)) + THECOLUMN
RETURN

' ----------------------------------------------------------
'                PLAY GAME
' -----------------------------------------------------------
PLAYGAME:
DRAWSCREEN 'DRAW THE SCREEN AND CREATE X AND O SYMBOLS.
FOR I = 1 TO 9: ZO(I) = FALSE: ZX(I) = FALSE: ZE(I) = TRUE: NEXT I
MOVESMADE = 0
DO
    GETUSERSIGNAL
    IF CLICK THEN
        MADEAMOVE = FALSE
        GOSUB MAKEX
        IF MADEAMOVE THEN
            WHOWON = 1: GOSUB COMPUTEWIN: IF WHOWON = 1 THEN RETURN
            T% = 0
            FOR I = 1 TO 9: T% = T% + ZX(I): NEXT I
            IF T% = -5 THEN WHOWON = 0: RETURN
            MOVESMADE = MOVESMADE + 1
            GOSUB MAKEO
            WHOWON = 2: GOSUB COMPUTEWIN: IF WHOWON = 2 THEN RETURN
        END IF
    END IF
    IF CC = "D" OR CC = CHR$(27) THEN WHOWON = 3
    IF WHOWON > 0 THEN RETURN
LOOP

MAKEX:
GOSUB FINDCLICKEDPOSITION
IF THEBOX = 0 THEN RETURN
IF NOT ZE(THEBOX) THEN RETURN
XO THEROW, THECOLUMN, 1: ' PLACES AN X
ZX(THEBOX) = TRUE: ZE(THEBOX) = FALSE
MADEAMOVE = TRUE
RETURN

MAKEO:
GOSUB FINDPLACEFORO
SLEEP 1: WHILE INKEY$ <> "": WEND
XO THEROW, THECOLUMN, 0: 'PLACES AN O
ZO(THEBOX) = TRUE: ZE(THEBOX) = FALSE
RETURN

COMPUTEWIN:
IF WHOWON = 1 THEN
    IF XWIN(1, 2, 3, 1) THEN RETURN
    IF XWIN(4, 5, 6, 2) THEN RETURN
    IF XWIN(7, 8, 9, 3) THEN RETURN
    IF XWIN(1, 4, 7, 4) THEN RETURN
    IF XWIN(2, 5, 8, 5) THEN RETURN
    IF XWIN(3, 6, 9, 6) THEN RETURN
    IF XWIN(1, 5, 9, 7) THEN RETURN
    IF XWIN(3, 5, 7, 8) THEN RETURN
ELSE
    IF OWIN(1, 2, 3, 1) THEN RETURN
    IF OWIN(4, 5, 6, 2) THEN RETURN
    IF OWIN(7, 8, 9, 3) THEN RETURN
    IF OWIN(1, 4, 7, 4) THEN RETURN
    IF OWIN(2, 5, 8, 5) THEN RETURN
    IF OWIN(3, 6, 9, 6) THEN RETURN
    IF OWIN(1, 5, 9, 7) THEN RETURN
    IF OWIN(3, 5, 7, 8) THEN RETURN
END IF
WHOWON = 0
RETURN

FINDPLACEFORO:
' SEE IF THERE IS A WIN FOR O. IF SO, TAKE IT.
' SEE IF THERE IS A THREAT OF A WIN FOR X. IF SO, BLOCK IT.
FOR TESTTYPE% = 1 TO 2
    THEBOX = 0
    FOR THEROW = 1 TO 3: FOR THECOLUMN = 1 TO 3
            THEBOX = THEBOX + 1
            IF ZE(THEBOX) THEN
                TK$ = ""
                SELECT CASE THEBOX
                    CASE 1: TK$ = "234759"
                    CASE 2: TK$ = "1358"
                    CASE 3: TK$ = "126957"
                    CASE 4: TK$ = "1756"
                    CASE 5: TK$ = "19283746"
                    CASE 6: TK$ = "4539"
                    CASE 7: TK$ = "148935"
                    CASE 8: TK$ = "2579"
                    CASE 9: TK$ = "153678"
                END SELECT
                FOR I = 1 TO LEN(TK$) STEP 2
                    J = VAL(MID$(TK$, I, 1))
                    K = VAL(MID$(TK$, I + 1, 1))
                    IF TESTTYPE% = 1 THEN
                        IF ZO(J) + ZO(K) < -1 THEN RETURN
                    ELSE
                        IF ZX(J) + ZX(K) < -1 THEN RETURN
                    END IF
                NEXT I
            END IF
    NEXT THECOLUMN: NEXT THEROW
NEXT TESTTYPE%
' NO MOVE SELECTED ABOVE TO WIN OR BLOCK WIN, SO
IF HARD THEN
    IF MOVESMADE = 1 THEN
        IF ZE(5) THEN
            THEROW = 2: THECOLUMN = 2: THEBOX = 5
        ELSE
            IF RND > .5 THEN THEROW = 1 ELSE THEROW = 3
            IF RND > .5 THEN THECOLUMN = 1 ELSE THECOLUMN = 3
            THEBOX = (3 * (THEROW - 1)) + THECOLUMN
        END IF
        RETURN
    ELSEIF MOVESMADE = 2 THEN
        IF ZX(5) THEN
            TK$ = ""
            IF ZO(1) AND ZX(9) THEN
                TK$ = "37"
            ELSEIF ZO(3) AND ZX(7) THEN
                TK$ = "19"
            ELSEIF ZO(7) AND ZX(3) THEN
                TK$ = "19"
            ELSEIF ZO(9) AND ZX(1) THEN
                TK$ = "37"
            END IF
            IF TK$ <> "" THEN
                IF RND > .5 THEN
                    THEBOX = VAL(LEFT$(TK$, 1))
                ELSE
                    THEBOX = VAL(LEFT$(TK$, 1))
                END IF
                THEROW = (THEBOX + 2) \ 3
                THECOLUMN = THEBOX - (3 * (THEROW - 1))
                RETURN
            END IF
        ELSE
            DO
                DO: THEBOX = 2 * INT(1 + (RND * 4)): LOOP WHILE NOT ZE(THEBOX)
                SELECT CASE THEBOX
                    CASE 2: IF NOT ZX(8) THEN EXIT DO
                    CASE 4: IF NOT ZX(6) THEN EXIT DO
                    CASE 6: IF NOT ZX(4) THEN EXIT DO
                    CASE 8: IF NOT ZX(2) THEN EXIT DO
                END SELECT
            LOOP
            THEROW = (THEBOX + 2) \ 3
            THECOLUMN = THEBOX - (3 * (THEROW - 1))
            RETURN
        END IF
    END IF
END IF
' OK, NO GOOD MOVE WAS FOUND. MAKE A RANDOM ONE
DO: THEBOX = 1 + INT(RND * 9): LOOP WHILE NOT ZE(THEBOX)
THEROW = (THEBOX + 2) \ 3
THECOLUMN = THEBOX - (3 * (THEROW - 1))
RETURN

SHUFFLE:
DO WHILE LEN(W1$) < 4
    R% = 1 + INT(RND * 4)
    IF MID$(W2$, R%, 1) <> "X" THEN
        W1$ = W1$ + MID$(W2$, R%, 1)
        MID$(W2$, R%, 1) = "X"
    END IF
LOOP
RETURN

SHOWWHOWON:
SELECT CASE WHOWON
    CASE 0: C$ = "TIE! "
    CASE 1: C$ = "YOU WIN! "
    CASE 2: C$ = "YOU LOSE! "
    CASE 3: C$ = "YOU RESIGNED?"
END SELECT
IF WHOWON < 3 THEN SLEEP 2: WHILE INKEY$ <> "": WEND
CLS
FOR I = 1 TO 30
    COLOR 1 + INT(RND * 15)
    LOCATE I, I + 20
    PRINT C$;
NEXT I
SLEEP 3: WHILE INKEY$ <> "": WEND
RETURN

INITIALIZESCREEN:
CLS
COLOR 15
LOCATE 4, 23: PRINT "TIC TAC TOE BY PAUL MEYER & THEBOB"
LOCATE 6, 27: PRINT "(C) 2004 - 2007 DOS-ID GAMES"
COLOR 3
DS% = 131: DD% = 97: DZ% = 75
LINE (DS%, 343)-(DS% + DZ%, 380), , BF
LINE (DS% + (1 * DD%), 343)-(DS% + (1 * DD%) + DZ%, 380), , BF
LINE (DS% + (2 * DD%), 343)-(DS% + (2 * DD%) + DZ%, 380), , BF
LINE (DS% + (3 * DD%), 343)-(DS% + (3 * DD%) + DZ%, 380), , BF
LOCATE 23, 19: PRINT " EASY ";
LOCATE , 31: PRINT " HARD ";
LOCATE , 43: PRINT " INFO ";
LOCATE , 55: PRINT " QUIT "
RETURN

FINDCLICKEDCOMMAND:
COMMAND = 0
SELECT CASE CV
    CASE IS < 343: RETURN
    CASE IS > 380: RETURN
END SELECT
SELECT CASE CH
    CASE IS < 130: RETURN
    CASE IS < 205: COMMAND = 1
    CASE IS < 227: RETURN
    CASE IS < 303: COMMAND = 2
    CASE IS < 325: RETURN
    CASE IS < 400: COMMAND = 3
    CASE IS < 421: RETURN
    CASE IS < 497: COMMAND = 4
END SELECT
RETURN


DOHELP:
CLS
COLOR 2
LOCATE 3, 1
PRINT "CREDITS"
PRINT "-------"
PRINT "THIS GAME WAS CREATED BY PAUL MEYER IN THE YEAR 2007."
PRINT: PRINT "GRAPHICS BY THEBOB"
PRINT: PRINT "IMPROVED MOUSE DRIVER, MODULARITY, MACHINE PLAY-TO-WIN";
PRINT " BY QBASIC MAC"
PRINT: PRINT "HISTORY:"
PRINT "HTTP://WWW.NETWORK54.COM/FORUM/190883/MESSAGE/1175106480"
PRINT
PRINT "THIS IS FREEWARE, YOU MAY CHANGE THIS AS MUCH AS YOU WANT"
PRINT "AS LONG AS YOU DON'T CLAIM IT AS YOURS."
PRINT
PRINT
PRINT "ABOUT"
PRINT "-----"
PRINT "THIS IS JUST A SIMPLE TIC TAC TOE GAME WITH MOUSE DRIVERS."
PRINT "THIS GAME WAS CREATED IN QUICKBASIC."
CALL GETUSERSIGNAL
CLS
RETURN

SUB DRAWSCREEN
    DIM X AS INTEGER, Y AS INTEGER
    STATIC FINISHED AS INTEGER
    CLS
    OUT &H3C8, 0: OUT &H3C9, 0: OUT &H3C9, 0: OUT &H3C9, 18
    OUT &H3C8, 4: OUT &H3C9, 63: OUT &H3C9, 0: OUT &H3C9, 0
    OUT &H3C8, 9: OUT &H3C9, 0: OUT &H3C9, 12: OUT &H3C9, 48
    OUT &H3C8, 11: OUT &H3C9, 0: OUT &H3C9, 18: OUT &H3C9, 54
    COLOR 7: LOCATE 3, 31: PRINT "T I C - T A C - T O E"
    LINE (170, 90)-(490, 410), 0, BF
    LINE (160, 81)-(479, 399), 1, BF
    LINE (155, 76)-(483, 404), 8, B
    LINE (152, 73)-(487, 407), 8, B
    LINE (160, 81)-(160, 399), 9
    LINE (160, 81)-(479, 81), 9
    LINE (371, 92)-(372, 393), 0, B
    LINE (271, 92)-(272, 392), 0, B
    LINE (171, 191)-(472, 192), 0, B
    LINE (171, 291)-(472, 292), 0, B
    LINE (369, 90)-(370, 390), 13, B
    LINE (269, 90)-(270, 390), 13, B
    LINE (169, 189)-(470, 190), 13, B
    LINE (169, 289)-(470, 290), 13, B
    LINE (5, 5)-(634, 474), 8, B
    LINE (10, 10)-(629, 469), 8, B
    IF FINISHED THEN EXIT SUB
    FINISHED = TRUE
    FOR X = 194 TO 500
        FOR Y = 32 TO 46
            IF POINT(X, Y) = 8 THEN PSET (X, Y), 7
        NEXT Y
    NEXT X
    PSET (188, 108), 0
    DRAW "E3 F30 E30 F6 G30 F30 G6 H30 G30 H6 E30 H30 E3 BF2 P0,0"
    PSET (186, 106), 10
    DRAW "E3 F30 E30 F6 G30 F30 G6 H30 G30 H6 E30 H30 E3 BF2 P10,10"
    CIRCLE (322, 141), 31, 0
    CIRCLE (322, 141), 37, 0
    PAINT STEP(0, 35), 0
    PSET STEP(0, -35), 0
    CIRCLE (320, 139), 31, 4
    CIRCLE (320, 139), 37, 4
    PAINT STEP(0, 35), 4
    PSET STEP(0, -35), 1
    GET STEP(-40, -40)-STEP(81, 81), SYMBOLBOX()
    GET (179, 98)-(260, 178), SYMBOLBOX(3000)
    XO 1, 1, 2: XO 1, 2, 2
END SUB

SUB ENABLEMOUSE (C%)
    STATIC STATUS AS INTEGER
    IF STATUS = 0 AND C% = 0 THEN EXIT SUB
    STATIC MX AS STRING
    IF MX = "" THEN
        M$ = "58E85080585080585080850815510C358508058508085080850815C00"
        N$ = "595BECB70BEAB70BE8BFBE6B7B8E7D33BEC978BEA97BE89FBE697DA80"
        MX = SPACE$(57)
        FOR I% = 1 TO 57
            H$ = CHR$(VAL("&H" + MID$(M$, I%, 1) + MID$(N$, I%, 1)))
            MID$(MX, I%, 1) = H$
        NEXT I%
    END IF
    IF C% = 0 THEN
        CALL ABSOLUTE(2, CLICK, CH, CV, SADD(MX))
        STATUS = 0
        EXIT SUB
    END IF
    IF STATUS = 0 THEN CALL ABSOLUTE(1, CLICK, CH, CV, SADD(MX))
    STATUS = 1
    CALL ABSOLUTE(3, CLICK, CH, CV, SADD(MX))
END SUB

SUB GETUSERSIGNAL
    DO
        IF 0 THEN ' SET TO 1 FOR DEBUGGING PRINTOUT, OTHERWISE 0
            LOCATE 2, 1
            PRINT CLICK; "<CLICK"
            PRINT CH; "CH (HORIZONTAL)"
            PRINT CV; "CV (VERTICLE)"
        END IF
        ENABLEMOUSE 1
        IF CLICK > 0 THEN
            K% = CLICK
            WHILE CLICK <> 0: ENABLEMOUSE 1: WEND
            CLICK = K%
            EXIT DO
        END IF
        CC = INKEY$
    LOOP WHILE CC = ""
    ENABLEMOUSE 0
END SUB

FUNCTION OWIN% (B1 AS INTEGER, B2 AS INTEGER, B3 AS INTEGER, L AS INTEGER)
    IF ZO(B1) = 0 OR ZO(B2) = 0 OR ZO(B3) = 0 THEN EXIT FUNCTION
    WINNER L
    OWIN% = -1
END FUNCTION

SUB WINNER (LINEUP AS INTEGER)
    SELECT CASE LINEUP
        CASE 1: LINE (200, 140)-(440, 142), 14, BF: LINE (200, 143)-(440, 144), 0, B
        CASE 2: LINE (200, 240)-(440, 242), 14, BF: LINE (200, 243)-(440, 244), 0, B
        CASE 3: LINE (200, 340)-(440, 342), 14, BF: LINE (200, 343)-(440, 344), 0, B
        CASE 4: LINE (220, 120)-(222, 360), 14, BF: LINE (223, 120)-(223, 360), 0
        CASE 5: LINE (320, 120)-(322, 360), 14, BF: LINE (323, 120)-(323, 360), 0
        CASE 6: LINE (420, 120)-(422, 360), 14, BF: LINE (423, 120)-(423, 360), 0
        CASE 7: PSET (200, 120), 14: DRAW "F240 D H240 D F240 D H240 D C0 F240 D H240"
        CASE 8: PSET (440, 120), 14: DRAW "G240 D E240 D G240 D E240 D C0 G240 D E240"
    END SELECT
END SUB

SUB XO (ROW AS INTEGER, COL AS INTEGER, SYMBOL AS INTEGER)
    DIM INDEX AS INTEGER, X AS INTEGER, Y AS INTEGER
    X = (COL - 1) * 100 + 180
    Y = (ROW - 1) * 100 + 100
    INDEX = SYMBOL * 3000
    IF INDEX < 6000 THEN
        PUT (X, Y), SYMBOLBOX(INDEX), PSET
    ELSE
        LINE (X, Y)-(X + 80, Y + 80), 1, BF
    END IF
END SUB

FUNCTION XWIN% (B1 AS INTEGER, B2 AS INTEGER, B3 AS INTEGER, L AS INTEGER)
    IF ZX(B1) = 0 OR ZX(B2) = 0 OR ZX(B3) = 0 THEN EXIT FUNCTION
    WINNER L
    XWIN% = -1
END FUNCTION

